org.activiti.engine

## Class ProcessEngineConfiguration

- java.lang.Object
- - org.activiti.engine.ProcessEngineConfiguration

- All Implemented Interfaces:
    EngineServices

      public abstract class ProcessEngineConfiguration
      extends Object
      implements EngineServices

  Configuration information from which a process engine can be build.

  Most common is to create a process engine based on the default configuration file:

      ProcessEngine processEngine = ProcessEngineConfiguration
         .createProcessEngineConfigurationFromResourceDefault()
         .buildProcessEngine();

  To create a process engine programatic, without a configuration file, the first option is `createStandaloneProcessEngineConfiguration()`

      ProcessEngine processEngine = ProcessEngineConfiguration
         .createStandaloneProcessEngineConfiguration()
         .buildProcessEngine();

  This creates a new process engine with all the defaults to connect to a remote h2 database (jdbc:h2:tcp://localhost/activiti) in standalone mode. Standalone mode means that Activiti will manage the transactions on the JDBC connections that it creates. One transaction per service method. For a description of how to write the configuration files, see the userguide.

  The second option is great for testing: `#createStandalonInMemeProcessEngineConfiguration()`

      ProcessEngine processEngine = ProcessEngineConfiguration
         .createStandaloneInMemProcessEngineConfiguration()
         .buildProcessEngine();

  This creates a new process engine with all the defaults to connect to an memory h2 database (jdbc:h2:tcp://localhost/activiti) in standalone mode. The DB schema strategy default is in this case `create-drop`. Standalone mode means that Activiti will manage the transactions on the JDBC connections that it creates. One transaction per service method.

  On all forms of creating a process engine, you can first customize the configuration before calling the `buildProcessEngine()` method by calling any of the setters like this:

      ProcessEngine processEngine = ProcessEngineConfiguration
         .createProcessEngineConfigurationFromResourceDefault()
         .setMailServerHost("gmail.com")
         .setJdbcUsername("mickey")
         .setJdbcPassword("mouse")
         .buildProcessEngine();

  Author:
    Tom Baeyens
  See Also:
    `ProcessEngines`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String` | `activityFontName`
    `protected String` | `annotationFontName`
    `protected org.activiti.engine.impl.asyncexecutor.AsyncExecutor` | `asyncExecutor`
    `protected boolean` | `asyncExecutorActivate`
    `protected boolean` | `asyncExecutorEnabled`
    `protected int` | `asyncFailedJobWaitTime` define the default wait time for a failed async job in seconds
    `protected ClassLoader` | `classLoader`
    `protected Clock` | `clock`
    `protected String` | `databaseCatalog` database catalog to use
    `protected String` | `databaseSchema` In some situations you want to set the schema to use for table checks / generation if the database metadata doesn't return that correctly, see https://activiti.atlassian.net/browse/ACT-1220, https://activiti.atlassian.net/browse/ACT-1062
    `protected String` | `databaseSchemaUpdate`
    `protected String` | `databaseTablePrefix` Allows configuring a database table prefix which is used for all runtime operations of the process engine.
    `protected String` | `databaseType`
    `protected String` | `databaseWildcardEscapeCharacter` Escape character for doing wildcard searches.
    `protected DataSource` | `dataSource`
    `protected String` | `dataSourceJndiName`
    `static String` | `DB_SCHEMA_UPDATE_CREATE_DROP` Creates the schema when the process engine is being created and drops the schema when the process engine is being closed.
    `static String` | `DB_SCHEMA_UPDATE_FALSE` Checks the version of the DB schema against the library when the process engine is being created and throws an exception if the versions don't match.
    `static String` | `DB_SCHEMA_UPDATE_TRUE` Upon building of the process engine, a check is performed and an update of the schema is performed if it is necessary.
    `protected String` | `defaultCamelContext`
    `protected int` | `defaultFailedJobWaitTime` define the default wait time for a failed job in seconds
    `protected boolean` | `enableProcessDefinitionInfoCache`
    `protected String` | `history`
    `protected org.activiti.engine.impl.history.HistoryLevel` | `historyLevel`
    `protected int` | `idBlockSize`
    `protected boolean` | `isCreateDiagramOnDeploy`
    `protected boolean` | `isDbHistoryUsed`
    `protected boolean` | `isDbIdentityUsed`
    `protected int` | `jdbcDefaultTransactionIsolationLevel`
    `protected String` | `jdbcDriver`
    `protected int` | `jdbcMaxActiveConnections`
    `protected int` | `jdbcMaxCheckoutTime`
    `protected int` | `jdbcMaxIdleConnections`
    `protected int` | `jdbcMaxWaitTime`
    `protected String` | `jdbcPassword`
    `protected int` | `jdbcPingConnectionNotUsedFor`
    `protected boolean` | `jdbcPingEnabled`
    `protected String` | `jdbcPingQuery`
    `protected String` | `jdbcUrl`
    `protected String` | `jdbcUsername`
    `protected org.activiti.engine.impl.jobexecutor.JobExecutor` | `jobExecutor`
    `protected boolean` | `jobExecutorActivate`
    `protected boolean` | `jpaCloseEntityManager`
    `protected Object` | `jpaEntityManagerFactory`
    `protected boolean` | `jpaHandleTransaction`
    `protected String` | `jpaPersistenceUnitName`
    `protected String` | `labelFontName`
    `protected int` | `lockTimeAsyncJobWaitTime` Define the default lock time for an async job in seconds.
    `protected String` | `mailServerDefaultFrom`
    `protected String` | `mailServerHost`
    `protected String` | `mailServerPassword`
    `protected int` | `mailServerPort`
    `protected Map<String,MailServerInfo>` | `mailServers`
    `protected String` | `mailServerUsername`
    `protected String` | `mailSessionJndi`
    `protected Map<String,String>` | `mailSessionsJndi`
    `static String` | `NO_TENANT_ID` The tenant id indicating 'no tenant'
    `protected org.activiti.image.ProcessDiagramGenerator` | `processDiagramGenerator` process diagram generator.
    `protected ProcessEngineLifecycleListener` | `processEngineLifecycleListener`
    `protected String` | `processEngineName`
    `protected boolean` | `tablePrefixIsSchema` Set to true in case the defined databaseTablePrefix is a schema-name, instead of an actual table name prefix.
    `protected boolean` | `transactionsExternallyManaged`
    `protected boolean` | `useClassForNameClassLoading` Either use Class.forName or ClassLoader.loadClass for class loading.
    `protected boolean` | `useSSL`
    `protected boolean` | `useTLS`
    `protected String` | `xmlEncoding`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ProcessEngineConfiguration()` use one of the static createXxxx methods instead

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract ProcessEngine` | `buildProcessEngine()`
    `static ProcessEngineConfiguration` | `createProcessEngineConfigurationFromInputStream(InputStream inputStream)`
    `static ProcessEngineConfiguration` | `createProcessEngineConfigurationFromInputStream(InputStream inputStream, String beanName)`
    `static ProcessEngineConfiguration` | `createProcessEngineConfigurationFromResource(String resource)`
    `static ProcessEngineConfiguration` | `createProcessEngineConfigurationFromResource(String resource, String beanName)`
    `static ProcessEngineConfiguration` | `createProcessEngineConfigurationFromResourceDefault()`
    `static ProcessEngineConfiguration` | `createStandaloneInMemProcessEngineConfiguration()`
    `static ProcessEngineConfiguration` | `createStandaloneProcessEngineConfiguration()`
    `String` | `getActivityFontName()`
    `String` | `getAnnotationFontName()`
    `org.activiti.engine.impl.asyncexecutor.AsyncExecutor` | `getAsyncExecutor()`
    `int` | `getAsyncFailedJobWaitTime()`
    `ClassLoader` | `getClassLoader()`
    `Clock` | `getClock()`
    `String` | `getDatabaseCatalog()`
    `String` | `getDatabaseSchema()`
    `String` | `getDatabaseSchemaUpdate()`
    `String` | `getDatabaseTablePrefix()`
    `String` | `getDatabaseType()`
    `String` | `getDatabaseWildcardEscapeCharacter()`
    `DataSource` | `getDataSource()`
    `String` | `getDataSourceJndiName()`
    `String` | `getDefaultCamelContext()`
    `int` | `getDefaultFailedJobWaitTime()`
    `String` | `getHistory()`
    `org.activiti.engine.impl.history.HistoryLevel` | `getHistoryLevel()`
    `int` | `getIdBlockSize()`
    `int` | `getJdbcDefaultTransactionIsolationLevel()`
    `String` | `getJdbcDriver()`
    `int` | `getJdbcMaxActiveConnections()`
    `int` | `getJdbcMaxCheckoutTime()`
    `int` | `getJdbcMaxIdleConnections()`
    `int` | `getJdbcMaxWaitTime()`
    `String` | `getJdbcPassword()`
    `int` | `getJdbcPingConnectionNotUsedFor()`
    `String` | `getJdbcPingQuery()`
    `String` | `getJdbcUrl()`
    `String` | `getJdbcUsername()`
    `org.activiti.engine.impl.jobexecutor.JobExecutor` | `getJobExecutor()`
    `Object` | `getJpaEntityManagerFactory()`
    `String` | `getJpaPersistenceUnitName()`
    `String` | `getLabelFontName()`
    `int` | `getLockTimeAsyncJobWaitTime()`
    `MailServerInfo` | `getMailServer(String tenantId)`
    `String` | `getMailServerDefaultFrom()`
    `String` | `getMailServerHost()`
    `String` | `getMailServerPassword()`
    `int` | `getMailServerPort()`
    `Map<String,MailServerInfo>` | `getMailServers()`
    `String` | `getMailServerUsername()`
    `boolean` | `getMailServerUseSSL()`
    `boolean` | `getMailServerUseTLS()`
    `String` | `getMailSessionJndi()`
    `String` | `getMailSessionJndi(String tenantId)`
    `Map<String,String>` | `getMailSessionsJndi()`
    `org.activiti.image.ProcessDiagramGenerator` | `getProcessDiagramGenerator()`
    `ProcessEngineLifecycleListener` | `getProcessEngineLifecycleListener()`
    `String` | `getProcessEngineName()`
    `String` | `getXmlEncoding()`
    `boolean` | `isAsyncExecutorActivate()`
    `boolean` | `isAsyncExecutorEnabled()`
    `boolean` | `isCreateDiagramOnDeploy()`
    `boolean` | `isDbHistoryUsed()`
    `boolean` | `isDbIdentityUsed()`
    `boolean` | `isEnableProcessDefinitionInfoCache()`
    `boolean` | `isJdbcPingEnabled()`
    `boolean` | `isJobExecutorActivate()`
    `boolean` | `isJpaCloseEntityManager()`
    `boolean` | `isJpaHandleTransaction()`
    `boolean` | `isTablePrefixIsSchema()`
    `boolean` | `isTransactionsExternallyManaged()`
    `boolean` | `isUseClassForNameClassLoading()`
    `ProcessEngineConfiguration` | `setActivityFontName(String activityFontName)`
    `ProcessEngineConfiguration` | `setAnnotationFontName(String annotationFontName)`
    `ProcessEngineConfiguration` | `setAsyncExecutor(org.activiti.engine.impl.asyncexecutor.AsyncExecutor asyncExecutor)`
    `ProcessEngineConfiguration` | `setAsyncExecutorActivate(boolean asyncExecutorActivate)`
    `ProcessEngineConfiguration` | `setAsyncExecutorEnabled(boolean asyncExecutorEnabled)`
    `ProcessEngineConfiguration` | `setAsyncFailedJobWaitTime(int asyncFailedJobWaitTime)`
    `ProcessEngineConfiguration` | `setClassLoader(ClassLoader classLoader)`
    `ProcessEngineConfiguration` | `setClock(Clock clock)`
    `ProcessEngineConfiguration` | `setCreateDiagramOnDeploy(boolean createDiagramOnDeploy)`
    `ProcessEngineConfiguration` | `setDatabaseCatalog(String databaseCatalog)`
    `ProcessEngineConfiguration` | `setDatabaseSchema(String databaseSchema)`
    `ProcessEngineConfiguration` | `setDatabaseSchemaUpdate(String databaseSchemaUpdate)`
    `ProcessEngineConfiguration` | `setDatabaseTablePrefix(String databaseTablePrefix)`
    `ProcessEngineConfiguration` | `setDatabaseType(String databaseType)`
    `ProcessEngineConfiguration` | `setDatabaseWildcardEscapeCharacter(String databaseWildcardEscapeCharacter)`
    `ProcessEngineConfiguration` | `setDataSource(DataSource dataSource)`
    `ProcessEngineConfiguration` | `setDataSourceJndiName(String dataSourceJndiName)`
    `ProcessEngineConfiguration` | `setDbHistoryUsed(boolean isDbHistoryUsed)`
    `ProcessEngineConfiguration` | `setDbIdentityUsed(boolean isDbIdentityUsed)`
    `ProcessEngineConfiguration` | `setDefaultCamelContext(String defaultCamelContext)`
    `ProcessEngineConfiguration` | `setDefaultFailedJobWaitTime(int defaultFailedJobWaitTime)`
    `ProcessEngineConfiguration` | `setEnableProcessDefinitionInfoCache(boolean enableProcessDefinitionInfoCache)`
    `ProcessEngineConfiguration` | `setHistory(String history)`
    `ProcessEngineConfiguration` | `setHistoryLevel(org.activiti.engine.impl.history.HistoryLevel historyLevel)`
    `ProcessEngineConfiguration` | `setIdBlockSize(int idBlockSize)`
    `ProcessEngineConfiguration` | `setJdbcDefaultTransactionIsolationLevel(int jdbcDefaultTransactionIsolationLevel)`
    `ProcessEngineConfiguration` | `setJdbcDriver(String jdbcDriver)`
    `ProcessEngineConfiguration` | `setJdbcMaxActiveConnections(int jdbcMaxActiveConnections)`
    `ProcessEngineConfiguration` | `setJdbcMaxCheckoutTime(int jdbcMaxCheckoutTime)`
    `ProcessEngineConfiguration` | `setJdbcMaxIdleConnections(int jdbcMaxIdleConnections)`
    `ProcessEngineConfiguration` | `setJdbcMaxWaitTime(int jdbcMaxWaitTime)`
    `ProcessEngineConfiguration` | `setJdbcPassword(String jdbcPassword)`
    `ProcessEngineConfiguration` | `setJdbcPingConnectionNotUsedFor(int jdbcPingNotUsedFor)`
    `ProcessEngineConfiguration` | `setJdbcPingEnabled(boolean jdbcPingEnabled)`
    `ProcessEngineConfiguration` | `setJdbcPingQuery(String jdbcPingQuery)`
    `ProcessEngineConfiguration` | `setJdbcUrl(String jdbcUrl)`
    `ProcessEngineConfiguration` | `setJdbcUsername(String jdbcUsername)`
    `ProcessEngineConfiguration` | `setJobExecutor(org.activiti.engine.impl.jobexecutor.JobExecutor jobExecutor)`
    `ProcessEngineConfiguration` | `setJobExecutorActivate(boolean jobExecutorActivate)`
    `ProcessEngineConfiguration` | `setJpaCloseEntityManager(boolean jpaCloseEntityManager)`
    `ProcessEngineConfiguration` | `setJpaEntityManagerFactory(Object jpaEntityManagerFactory)`
    `ProcessEngineConfiguration` | `setJpaHandleTransaction(boolean jpaHandleTransaction)`
    `ProcessEngineConfiguration` | `setJpaPersistenceUnitName(String jpaPersistenceUnitName)`
    `ProcessEngineConfiguration` | `setLabelFontName(String labelFontName)`
    `ProcessEngineConfiguration` | `setLockTimeAsyncJobWaitTime(int lockTimeAsyncJobWaitTime)`
    `ProcessEngineConfiguration` | `setMailServerDefaultFrom(String mailServerDefaultFrom)`
    `ProcessEngineConfiguration` | `setMailServerHost(String mailServerHost)`
    `ProcessEngineConfiguration` | `setMailServerPassword(String mailServerPassword)`
    `ProcessEngineConfiguration` | `setMailServerPort(int mailServerPort)`
    `ProcessEngineConfiguration` | `setMailServers(Map<String,MailServerInfo> mailServers)`
    `ProcessEngineConfiguration` | `setMailServerUsername(String mailServerUsername)`
    `ProcessEngineConfiguration` | `setMailServerUseSSL(boolean useSSL)`
    `ProcessEngineConfiguration` | `setMailServerUseTLS(boolean useTLS)`
    `ProcessEngineConfiguration` | `setMailSessionJndi(String mailSessionJndi)`
    `ProcessEngineConfiguration` | `setMailSessionsJndi(Map<String,String> mailSessionsJndi)`
    `ProcessEngineConfiguration` | `setProcessDiagramGenerator(org.activiti.image.ProcessDiagramGenerator processDiagramGenerator)`
    `ProcessEngineConfiguration` | `setProcessEngineLifecycleListener(ProcessEngineLifecycleListener processEngineLifecycleListener)`
    `ProcessEngineConfiguration` | `setProcessEngineName(String processEngineName)`
    `ProcessEngineConfiguration` | `setTablePrefixIsSchema(boolean tablePrefixIsSchema)`
    `ProcessEngineConfiguration` | `setTransactionsExternallyManaged(boolean transactionsExternallyManaged)`
    `ProcessEngineConfiguration` | `setUseClassForNameClassLoading(boolean useClassForNameClassLoading)`
    `ProcessEngineConfiguration` | `setXmlEncoding(String xmlEncoding)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.activiti.engine.EngineServices

      `getDynamicBpmnService, getFormService, getHistoryService, getIdentityService, getManagementService, getProcessEngineConfiguration, getRepositoryService, getRuntimeService, getTaskService`

- - ### Field Detail

    - #### DB_SCHEMA_UPDATE_FALSE

          public static final String DB_SCHEMA_UPDATE_FALSE

      Checks the version of the DB schema against the library when the process engine is being created and throws an exception if the versions don't match.
      See Also:
        Constant Field Values

    - #### DB_SCHEMA_UPDATE_CREATE_DROP

          public static final String DB_SCHEMA_UPDATE_CREATE_DROP

      Creates the schema when the process engine is being created and drops the schema when the process engine is being closed.
      See Also:
        Constant Field Values

    - #### DB_SCHEMA_UPDATE_TRUE

          public static final String DB_SCHEMA_UPDATE_TRUE

      Upon building of the process engine, a check is performed and an update of the schema is performed if it is necessary.
      See Also:
        Constant Field Values

    - #### NO_TENANT_ID

          public static final String NO_TENANT_ID

      The tenant id indicating 'no tenant'
      See Also:
        Constant Field Values

    - #### processEngineName

          protected String processEngineName

    - #### idBlockSize

          protected int idBlockSize

    - #### history

          protected String history

    - #### jobExecutorActivate

          protected boolean jobExecutorActivate

    - #### asyncExecutorEnabled

          protected boolean asyncExecutorEnabled

    - #### asyncExecutorActivate

          protected boolean asyncExecutorActivate

    - #### mailServerHost

          protected String mailServerHost

    - #### mailServerUsername

          protected String mailServerUsername

    - #### mailServerPassword

          protected String mailServerPassword

    - #### mailServerPort

          protected int mailServerPort

    - #### useSSL

          protected boolean useSSL

    - #### useTLS

          protected boolean useTLS

    - #### mailServerDefaultFrom

          protected String mailServerDefaultFrom

    - #### mailSessionJndi

          protected String mailSessionJndi

    - #### mailServers

          protected Map<String,MailServerInfo> mailServers

    - #### mailSessionsJndi

          protected Map<String,String> mailSessionsJndi

    - #### databaseType

          protected String databaseType

    - #### databaseSchemaUpdate

          protected String databaseSchemaUpdate

    - #### jdbcDriver

          protected String jdbcDriver

    - #### jdbcUrl

          protected String jdbcUrl

    - #### jdbcUsername

          protected String jdbcUsername

    - #### jdbcPassword

          protected String jdbcPassword

    - #### dataSourceJndiName

          protected String dataSourceJndiName

    - #### isDbIdentityUsed

          protected boolean isDbIdentityUsed

    - #### isDbHistoryUsed

          protected boolean isDbHistoryUsed

    - #### historyLevel

          protected org.activiti.engine.impl.history.HistoryLevel historyLevel

    - #### jdbcMaxActiveConnections

          protected int jdbcMaxActiveConnections

    - #### jdbcMaxIdleConnections

          protected int jdbcMaxIdleConnections

    - #### jdbcMaxCheckoutTime

          protected int jdbcMaxCheckoutTime

    - #### jdbcMaxWaitTime

          protected int jdbcMaxWaitTime

    - #### jdbcPingEnabled

          protected boolean jdbcPingEnabled

    - #### jdbcPingQuery

          protected String jdbcPingQuery

    - #### jdbcPingConnectionNotUsedFor

          protected int jdbcPingConnectionNotUsedFor

    - #### jdbcDefaultTransactionIsolationLevel

          protected int jdbcDefaultTransactionIsolationLevel

    - #### dataSource

          protected DataSource dataSource

    - #### transactionsExternallyManaged

          protected boolean transactionsExternallyManaged

    - #### jpaPersistenceUnitName

          protected String jpaPersistenceUnitName

    - #### jpaEntityManagerFactory

          protected Object jpaEntityManagerFactory

    - #### jpaHandleTransaction

          protected boolean jpaHandleTransaction

    - #### jpaCloseEntityManager

          protected boolean jpaCloseEntityManager

    - #### clock

          protected Clock clock

    - #### jobExecutor

          protected org.activiti.engine.impl.jobexecutor.JobExecutor jobExecutor

    - #### asyncExecutor

          protected org.activiti.engine.impl.asyncexecutor.AsyncExecutor asyncExecutor

    - #### lockTimeAsyncJobWaitTime

          protected int lockTimeAsyncJobWaitTime

      Define the default lock time for an async job in seconds. The lock time is used when creating an async job and when it expires the async executor assumes that the job has failed. It will be retried again.

    - #### defaultFailedJobWaitTime

          protected int defaultFailedJobWaitTime

      define the default wait time for a failed job in seconds

    - #### asyncFailedJobWaitTime

          protected int asyncFailedJobWaitTime

      define the default wait time for a failed async job in seconds

    - #### processDiagramGenerator

          protected org.activiti.image.ProcessDiagramGenerator processDiagramGenerator

      process diagram generator. Default value is DefaulProcessDiagramGenerator

    - #### databaseTablePrefix

          protected String databaseTablePrefix

      Allows configuring a database table prefix which is used for all runtime operations of the process engine. For example, if you specify a prefix named 'PRE1.', activiti will query for executions in a table named 'PRE1.ACT_RU_EXECUTION_'.

      NOTE: the prefix is not respected by automatic database schema management. If you use `DB_SCHEMA_UPDATE_CREATE_DROP` or `DB_SCHEMA_UPDATE_TRUE`, activiti will create the database tables using the default names, regardless of the prefix configured here.
      Since:
        5.9

    - #### databaseWildcardEscapeCharacter

          protected String databaseWildcardEscapeCharacter

      Escape character for doing wildcard searches. This will be added at then end of queries that include for example a LIKE clause. For example: SELECT * FROM table WHERE column LIKE '%\%%' ESCAPE '\';

    - #### databaseCatalog

          protected String databaseCatalog

      database catalog to use

    - #### databaseSchema

          protected String databaseSchema

      In some situations you want to set the schema to use for table checks / generation if the database metadata doesn't return that correctly, see https://activiti.atlassian.net/browse/ACT-1220, https://activiti.atlassian.net/browse/ACT-1062

    - #### tablePrefixIsSchema

          protected boolean tablePrefixIsSchema

      Set to true in case the defined databaseTablePrefix is a schema-name, instead of an actual table name prefix. This is relevant for checking if Activiti-tables exist, the databaseTablePrefix will not be used here - since the schema is taken into account already, adding a prefix for the table-check will result in wrong table-names.
      Since:
        5.15

    - #### isCreateDiagramOnDeploy

          protected boolean isCreateDiagramOnDeploy

    - #### xmlEncoding

          protected String xmlEncoding

    - #### defaultCamelContext

          protected String defaultCamelContext

    - #### activityFontName

          protected String activityFontName

    - #### labelFontName

          protected String labelFontName

    - #### annotationFontName

          protected String annotationFontName

    - #### classLoader

          protected ClassLoader classLoader

    - #### useClassForNameClassLoading

          protected boolean useClassForNameClassLoading

      Either use Class.forName or ClassLoader.loadClass for class loading. See http://forums.activiti.org/content/reflectutilloadclass-and-custom-classloader

    - #### processEngineLifecycleListener

          protected ProcessEngineLifecycleListener processEngineLifecycleListener

    - #### enableProcessDefinitionInfoCache

          protected boolean enableProcessDefinitionInfoCache

  - ### Constructor Detail

    - #### ProcessEngineConfiguration

          protected ProcessEngineConfiguration()

      use one of the static createXxxx methods instead

  - ### Method Detail

    - #### buildProcessEngine

          public abstract ProcessEngine buildProcessEngine()

    - #### createProcessEngineConfigurationFromResourceDefault

          public static ProcessEngineConfiguration createProcessEngineConfigurationFromResourceDefault()

    - #### createProcessEngineConfigurationFromResource

          public static ProcessEngineConfiguration createProcessEngineConfigurationFromResource(String resource)

    - #### createProcessEngineConfigurationFromResource

          public static ProcessEngineConfiguration createProcessEngineConfigurationFromResource(String resource,
                                                                                                String beanName)

    - #### createProcessEngineConfigurationFromInputStream

          public static ProcessEngineConfiguration createProcessEngineConfigurationFromInputStream(InputStream inputStream)

    - #### createProcessEngineConfigurationFromInputStream

          public static ProcessEngineConfiguration createProcessEngineConfigurationFromInputStream(InputStream inputStream,
                                                                                                   String beanName)

    - #### createStandaloneProcessEngineConfiguration

          public static ProcessEngineConfiguration createStandaloneProcessEngineConfiguration()

    - #### createStandaloneInMemProcessEngineConfiguration

          public static ProcessEngineConfiguration createStandaloneInMemProcessEngineConfiguration()

    - #### getProcessEngineName

          public String getProcessEngineName()

    - #### setProcessEngineName

          public ProcessEngineConfiguration setProcessEngineName(String processEngineName)

    - #### getIdBlockSize

          public int getIdBlockSize()

    - #### setIdBlockSize

          public ProcessEngineConfiguration setIdBlockSize(int idBlockSize)

    - #### getHistory

          public String getHistory()

    - #### setHistory

          public ProcessEngineConfiguration setHistory(String history)

    - #### getMailServerHost

          public String getMailServerHost()

    - #### setMailServerHost

          public ProcessEngineConfiguration setMailServerHost(String mailServerHost)

    - #### getMailServerUsername

          public String getMailServerUsername()

    - #### setMailServerUsername

          public ProcessEngineConfiguration setMailServerUsername(String mailServerUsername)

    - #### getMailServerPassword

          public String getMailServerPassword()

    - #### setMailServerPassword

          public ProcessEngineConfiguration setMailServerPassword(String mailServerPassword)

    - #### getMailSessionJndi

          public String getMailSessionJndi()

    - #### setMailSessionJndi

          public ProcessEngineConfiguration setMailSessionJndi(String mailSessionJndi)

    - #### getMailServerPort

          public int getMailServerPort()

    - #### setMailServerPort

          public ProcessEngineConfiguration setMailServerPort(int mailServerPort)

    - #### getMailServerUseSSL

          public boolean getMailServerUseSSL()

    - #### setMailServerUseSSL

          public ProcessEngineConfiguration setMailServerUseSSL(boolean useSSL)

    - #### getMailServerUseTLS

          public boolean getMailServerUseTLS()

    - #### setMailServerUseTLS

          public ProcessEngineConfiguration setMailServerUseTLS(boolean useTLS)

    - #### getMailServerDefaultFrom

          public String getMailServerDefaultFrom()

    - #### setMailServerDefaultFrom

          public ProcessEngineConfiguration setMailServerDefaultFrom(String mailServerDefaultFrom)

    - #### getMailServer

          public MailServerInfo getMailServer(String tenantId)

    - #### getMailServers

          public Map<String,MailServerInfo> getMailServers()

    - #### setMailServers

          public ProcessEngineConfiguration setMailServers(Map<String,MailServerInfo> mailServers)

    - #### getMailSessionJndi

          public String getMailSessionJndi(String tenantId)

    - #### getMailSessionsJndi

          public Map<String,String> getMailSessionsJndi()

    - #### setMailSessionsJndi

          public ProcessEngineConfiguration setMailSessionsJndi(Map<String,String> mailSessionsJndi)

    - #### getDatabaseType

          public String getDatabaseType()

    - #### setDatabaseType

          public ProcessEngineConfiguration setDatabaseType(String databaseType)

    - #### getDatabaseSchemaUpdate

          public String getDatabaseSchemaUpdate()

    - #### setDatabaseSchemaUpdate

          public ProcessEngineConfiguration setDatabaseSchemaUpdate(String databaseSchemaUpdate)

    - #### getDataSource

          public DataSource getDataSource()

    - #### setDataSource

          public ProcessEngineConfiguration setDataSource(DataSource dataSource)

    - #### getJdbcDriver

          public String getJdbcDriver()

    - #### setJdbcDriver

          public ProcessEngineConfiguration setJdbcDriver(String jdbcDriver)

    - #### getJdbcUrl

          public String getJdbcUrl()

    - #### setJdbcUrl

          public ProcessEngineConfiguration setJdbcUrl(String jdbcUrl)

    - #### getJdbcUsername

          public String getJdbcUsername()

    - #### setJdbcUsername

          public ProcessEngineConfiguration setJdbcUsername(String jdbcUsername)

    - #### getJdbcPassword

          public String getJdbcPassword()

    - #### setJdbcPassword

          public ProcessEngineConfiguration setJdbcPassword(String jdbcPassword)

    - #### isTransactionsExternallyManaged

          public boolean isTransactionsExternallyManaged()

    - #### setTransactionsExternallyManaged

          public ProcessEngineConfiguration setTransactionsExternallyManaged(boolean transactionsExternallyManaged)

    - #### getHistoryLevel

          public org.activiti.engine.impl.history.HistoryLevel getHistoryLevel()

    - #### setHistoryLevel

          public ProcessEngineConfiguration setHistoryLevel(org.activiti.engine.impl.history.HistoryLevel historyLevel)

    - #### isDbIdentityUsed

          public boolean isDbIdentityUsed()

    - #### setDbIdentityUsed

          public ProcessEngineConfiguration setDbIdentityUsed(boolean isDbIdentityUsed)

    - #### isDbHistoryUsed

          public boolean isDbHistoryUsed()

    - #### setDbHistoryUsed

          public ProcessEngineConfiguration setDbHistoryUsed(boolean isDbHistoryUsed)

    - #### getJdbcMaxActiveConnections

          public int getJdbcMaxActiveConnections()

    - #### setJdbcMaxActiveConnections

          public ProcessEngineConfiguration setJdbcMaxActiveConnections(int jdbcMaxActiveConnections)

    - #### getJdbcMaxIdleConnections

          public int getJdbcMaxIdleConnections()

    - #### setJdbcMaxIdleConnections

          public ProcessEngineConfiguration setJdbcMaxIdleConnections(int jdbcMaxIdleConnections)

    - #### getJdbcMaxCheckoutTime

          public int getJdbcMaxCheckoutTime()

    - #### setJdbcMaxCheckoutTime

          public ProcessEngineConfiguration setJdbcMaxCheckoutTime(int jdbcMaxCheckoutTime)

    - #### getJdbcMaxWaitTime

          public int getJdbcMaxWaitTime()

    - #### setJdbcMaxWaitTime

          public ProcessEngineConfiguration setJdbcMaxWaitTime(int jdbcMaxWaitTime)

    - #### isJdbcPingEnabled

          public boolean isJdbcPingEnabled()

    - #### setJdbcPingEnabled

          public ProcessEngineConfiguration setJdbcPingEnabled(boolean jdbcPingEnabled)

    - #### getJdbcPingQuery

          public String getJdbcPingQuery()

    - #### setJdbcPingQuery

          public ProcessEngineConfiguration setJdbcPingQuery(String jdbcPingQuery)

    - #### getJdbcPingConnectionNotUsedFor

          public int getJdbcPingConnectionNotUsedFor()

    - #### setJdbcPingConnectionNotUsedFor

          public ProcessEngineConfiguration setJdbcPingConnectionNotUsedFor(int jdbcPingNotUsedFor)

    - #### getJdbcDefaultTransactionIsolationLevel

          public int getJdbcDefaultTransactionIsolationLevel()

    - #### setJdbcDefaultTransactionIsolationLevel

          public ProcessEngineConfiguration setJdbcDefaultTransactionIsolationLevel(int jdbcDefaultTransactionIsolationLevel)

    - #### isJobExecutorActivate

          public boolean isJobExecutorActivate()

    - #### setJobExecutorActivate

          public ProcessEngineConfiguration setJobExecutorActivate(boolean jobExecutorActivate)

    - #### isAsyncExecutorEnabled

          public boolean isAsyncExecutorEnabled()

    - #### setAsyncExecutorEnabled

          public ProcessEngineConfiguration setAsyncExecutorEnabled(boolean asyncExecutorEnabled)

    - #### isAsyncExecutorActivate

          public boolean isAsyncExecutorActivate()

    - #### setAsyncExecutorActivate

          public ProcessEngineConfiguration setAsyncExecutorActivate(boolean asyncExecutorActivate)

    - #### getClassLoader

          public ClassLoader getClassLoader()

    - #### setClassLoader

          public ProcessEngineConfiguration setClassLoader(ClassLoader classLoader)

    - #### isUseClassForNameClassLoading

          public boolean isUseClassForNameClassLoading()

    - #### setUseClassForNameClassLoading

          public ProcessEngineConfiguration setUseClassForNameClassLoading(boolean useClassForNameClassLoading)

    - #### getJpaEntityManagerFactory

          public Object getJpaEntityManagerFactory()

    - #### setJpaEntityManagerFactory

          public ProcessEngineConfiguration setJpaEntityManagerFactory(Object jpaEntityManagerFactory)

    - #### isJpaHandleTransaction

          public boolean isJpaHandleTransaction()

    - #### setJpaHandleTransaction

          public ProcessEngineConfiguration setJpaHandleTransaction(boolean jpaHandleTransaction)

    - #### isJpaCloseEntityManager

          public boolean isJpaCloseEntityManager()

    - #### setJpaCloseEntityManager

          public ProcessEngineConfiguration setJpaCloseEntityManager(boolean jpaCloseEntityManager)

    - #### getJpaPersistenceUnitName

          public String getJpaPersistenceUnitName()

    - #### setJpaPersistenceUnitName

          public ProcessEngineConfiguration setJpaPersistenceUnitName(String jpaPersistenceUnitName)

    - #### getDataSourceJndiName

          public String getDataSourceJndiName()

    - #### setDataSourceJndiName

          public ProcessEngineConfiguration setDataSourceJndiName(String dataSourceJndiName)

    - #### getDefaultCamelContext

          public String getDefaultCamelContext()

    - #### setDefaultCamelContext

          public ProcessEngineConfiguration setDefaultCamelContext(String defaultCamelContext)

    - #### isCreateDiagramOnDeploy

          public boolean isCreateDiagramOnDeploy()

    - #### setCreateDiagramOnDeploy

          public ProcessEngineConfiguration setCreateDiagramOnDeploy(boolean createDiagramOnDeploy)

    - #### getActivityFontName

          public String getActivityFontName()

    - #### setActivityFontName

          public ProcessEngineConfiguration setActivityFontName(String activityFontName)

    - #### setProcessEngineLifecycleListener

          public ProcessEngineConfiguration setProcessEngineLifecycleListener(ProcessEngineLifecycleListener processEngineLifecycleListener)

    - #### getProcessEngineLifecycleListener

          public ProcessEngineLifecycleListener getProcessEngineLifecycleListener()

    - #### getLabelFontName

          public String getLabelFontName()

    - #### setLabelFontName

          public ProcessEngineConfiguration setLabelFontName(String labelFontName)

    - #### getAnnotationFontName

          public String getAnnotationFontName()

    - #### setAnnotationFontName

          public ProcessEngineConfiguration setAnnotationFontName(String annotationFontName)

    - #### getDatabaseTablePrefix

          public String getDatabaseTablePrefix()

    - #### setDatabaseTablePrefix

          public ProcessEngineConfiguration setDatabaseTablePrefix(String databaseTablePrefix)

    - #### setTablePrefixIsSchema

          public ProcessEngineConfiguration setTablePrefixIsSchema(boolean tablePrefixIsSchema)

    - #### isTablePrefixIsSchema

          public boolean isTablePrefixIsSchema()

    - #### getDatabaseWildcardEscapeCharacter

          public String getDatabaseWildcardEscapeCharacter()

    - #### setDatabaseWildcardEscapeCharacter

          public ProcessEngineConfiguration setDatabaseWildcardEscapeCharacter(String databaseWildcardEscapeCharacter)

    - #### getDatabaseCatalog

          public String getDatabaseCatalog()

    - #### setDatabaseCatalog

          public ProcessEngineConfiguration setDatabaseCatalog(String databaseCatalog)

    - #### getDatabaseSchema

          public String getDatabaseSchema()

    - #### setDatabaseSchema

          public ProcessEngineConfiguration setDatabaseSchema(String databaseSchema)

    - #### getXmlEncoding

          public String getXmlEncoding()

    - #### setXmlEncoding

          public ProcessEngineConfiguration setXmlEncoding(String xmlEncoding)

    - #### getClock

          public Clock getClock()

    - #### setClock

          public ProcessEngineConfiguration setClock(Clock clock)

    - #### getProcessDiagramGenerator

          public org.activiti.image.ProcessDiagramGenerator getProcessDiagramGenerator()

    - #### setProcessDiagramGenerator

          public ProcessEngineConfiguration setProcessDiagramGenerator(org.activiti.image.ProcessDiagramGenerator processDiagramGenerator)

    - #### getJobExecutor

          public org.activiti.engine.impl.jobexecutor.JobExecutor getJobExecutor()

    - #### setJobExecutor

          public ProcessEngineConfiguration setJobExecutor(org.activiti.engine.impl.jobexecutor.JobExecutor jobExecutor)

    - #### getAsyncExecutor

          public org.activiti.engine.impl.asyncexecutor.AsyncExecutor getAsyncExecutor()

    - #### setAsyncExecutor

          public ProcessEngineConfiguration setAsyncExecutor(org.activiti.engine.impl.asyncexecutor.AsyncExecutor asyncExecutor)

    - #### getLockTimeAsyncJobWaitTime

          public int getLockTimeAsyncJobWaitTime()

    - #### setLockTimeAsyncJobWaitTime

          public ProcessEngineConfiguration setLockTimeAsyncJobWaitTime(int lockTimeAsyncJobWaitTime)

    - #### getDefaultFailedJobWaitTime

          public int getDefaultFailedJobWaitTime()

    - #### setDefaultFailedJobWaitTime

          public ProcessEngineConfiguration setDefaultFailedJobWaitTime(int defaultFailedJobWaitTime)

    - #### getAsyncFailedJobWaitTime

          public int getAsyncFailedJobWaitTime()

    - #### setAsyncFailedJobWaitTime

          public ProcessEngineConfiguration setAsyncFailedJobWaitTime(int asyncFailedJobWaitTime)

    - #### isEnableProcessDefinitionInfoCache

          public boolean isEnableProcessDefinitionInfoCache()

    - #### setEnableProcessDefinitionInfoCache

          public ProcessEngineConfiguration setEnableProcessDefinitionInfoCache(boolean enableProcessDefinitionInfoCache)

Copyright © 2016 Alfresco. All rights reserved.